# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section free
%define namedversion 1.2.0-m1

Summary:        Spring OSGi
Name:           spring-osgi
Version:        1.2.0
Release:        0.m1.1%{?dist}
Epoch:          0
Group:          Development/Java
License:        Apache License 2.0
URL:            http://www.springframework.org/osgi
Source0:        http://downloads.sourceforge.net/springframework/spring-osgi-1.2.0-m1-with-dependencies.zip
Source1:        %{name}-jpp-depmap.xml
Source2:        %{name}-settings.xml

Patch0:         spring-osgi-pom.patch
Patch1:         spring-osgi-io-pom.patch
Patch2:         spring-osgi-extender-pom.patch
##

Patch3:         spring-osgi-test-support-AbstractConfigurableOsgiTests.patch
Patch4:         spring-osgi-test-support-Platforms.patch
Patch5:         spring-osgi-bundle-archetype-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  junit
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-surefire-plugin
BuildRequires:  apache-felix-maven-bundle-plugin

BuildRequires:  aopalliance
BuildRequires:  jetty6-core
BuildRequires:  knopflerfish
BuildRequires:  multithreadedtc
BuildRequires:  org.osgi.core
BuildRequires:  org.osgi.compendium
BuildRequires:  retrotranslator
BuildRequires:  servlet_2_5_api
BuildRequires:  spring2-aop
BuildRequires:  spring2-beans
BuildRequires:  spring2-context
BuildRequires:  spring2-core
BuildRequires:  spring2-test
BuildRequires:  tomcat5-server-lib


Requires:  java >= 0:1.6.0
Requires:  aopalliance
Requires:  knopflerfish
Requires:  multithreadedtc
Requires:  org.osgi.core
Requires:  org.osgi.compendium
#Requires:  retrotranslator
Requires:  servlet_2_5_api
Requires:  spring2-aop
Requires:  spring2-beans
Requires:  spring2-context
Requires:  spring2-core

Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The Spring Dynamic Modules for OSGi(tm) Service Platforms 
project makes it easy to build Spring applications that run
in an OSGi framework. A Spring application written in this 
way provides better separation of modules, the ability to 
dynamically add, remove, and update modules in a running 
system, the ability to deploy multiple versions of a module 
simultaneously (and have clients automatically bind to the 
appropriate one), and a dynamic service model.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
%{summary}.

%prep
%setup -q -n %{name}-%{namedversion}
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done

%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
###
%patch3 -b .sav3
%patch4 -b .sav4
%patch5 -b .sav5

# hangs
rm src/test-support/src/test/java/org/springframework/osgi/test/platform/FelixPlatformTest.java

mkdir -p src/docs/src/javadoc/
cp docs/api/javadoc.css src/docs/src/javadoc/javadoc.css
echo '<html><body></body></html>' > src/docs/src/javadoc/overview.html

%build
cp %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL/org/eclipse/osgi/org.eclipse.osgi/3.2.2/
#ln -sf %{_libdir}/eclipse/plugins/org.eclipse.osgi_*.jar \
#    $MAVEN_REPO_LOCAL/org/eclipse/osgi/org.eclipse.osgi/3.2.2/org.eclipse.osgi-3.2.2.jar
cp lib/org.eclipse.osgi-3.2.2.jar.no m2_repo/repository/org/eclipse/osgi/org.eclipse.osgi/3.2.2/org.eclipse.osgi-3.2.2.jar


cd src
mvn-jpp -e \
        -Pequinox,felix,knopflerfish \
        -s ${M2SETTINGS} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        install 

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Daggregate=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT
cd src

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}.pom
%add_to_maven_depmap org.springframework.osgi %{name} %{version} JPP/%{name} %{name}

for m in \
         annotation \
         bundle-archetype \
         core \
         extender \
         io \
         mock \
         web-extender \
         web \
              ; do

install -m 644 ${m}/target/%{name}-${m}-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/${m}-%{version}.jar
install -m 644 ${m}/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-${m}.pom
%add_to_maven_depmap org.springframework.osgi %{name}-${m} %{version} JPP/%{name} ${m}

done
install -m 644 test-support/target/%{name}-test-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/test-%{version}.jar
install -m 644 test-support/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-test.pom
%add_to_maven_depmap org.springframework.osgi %{name}-test %{version} JPP/%{name} test

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)


# javadoc
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms
%{_mavendepmapfragdir}
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%changelog
* Mon Jun 20 2011 Ralph Apel <r.apel at r-apel.de> 0:1.2.0-0.m1.1
- 1.2.0

* Thu Aug 07 2008 Ralph Apel <r.apel at r-apel.de> 0:1.1.0-1.jpp5
- Initial release

